#!/bin/bash
# auto_backup.sh (local) version 0.1 
# Author: Tzu-Yi Liao (steven@ms.ntcb.edu.tw)
# URL: http://www.l-penguin.idv.tw

#Config file
CNF_FILE=/backup/auto_backup/CONFIG
#Backup path (Base folder)
BASE=/backup/files
#LOG file
LOG=/backup/auto_backup/auto_backup.log
#Restore path
R_P=/backup/restore

! [ -f ${LOG} ] && echo "Can't find log file!" && exit 1;
! [ -f ${CNF_FILE} ] && echo "Can't find config file!" && exit 1;

echo "\n============ Start time: "`date`" ============" >> ${LOG}

ATR=$1

if [ "${ATR}" == "-b" ]; then
        if [ -d ${BASE} ]; then
                for i in `cat ${CNF_FILE}`
                do
                    d=""
                    f=""
                    t=""
                    d=`echo ${i} | awk -F '@' '{print $1}'`
                    f=`echo ${i} | awk -F '@' '{print $2}'`
                    t=`echo ${i} | awk -F '@' '{print $3}'`

                    if [ "${t}" == "f" ]; then
                       cd ${BASE}
                       mkdir -p .${d}
                       cp -rfpu ${d}${f} .${d}${f} 2>> ${LOG}
                    elif [ "${t}" == "d" ]; then
                       mkdir -p ${BASE}${d}
                       cd ${BASE}${d}
                       cp -rfpu ${d}${f} .  2>> ${LOG}
                    fi

                done
        else
                echo "Can't find base folder!"
                exit 1
        fi

elif [ "${ATR}" == "-r" ]; then
        ! [ -d ${R_P} ] && echo "Can't find restore folder!" && exit 1;

        if [ -d ${BASE} ]; then
                cd ${BASE}
                cp -rfpu * ${R_P} 2>> ${LOG}
        else
                echo "Can't find base folder!"
                exit 1
        fi
else
        echo "Please use \"-b\" to backup, or use \"-r\" to restore"
fi
echo "\n============ End time: "`date`" ============" >> ${LOG}
